#include <octave/oct.h>

DEFUN_DLD (direct_moments_fast, args, ,
  "[alpha,beta]=direct_moments_fast(Xi,lam,m) takes the place of direct_moments.m\n\
as called from build_catalouge_stack.")
{
  octave_value_list retval;

  int nargin = args.length ();
  if (nargin != 3)
    {
      print_usage ();
      return retval;
    }/* if */

  ComplexRowVector Xi (args(0).complex_row_vector_value ());
  RowVector lam (args(1).vector_value ());
  int m ( (int) args(2).double_value ());

  int n  = lam.length ();
  ComplexColumnVector h_mom(m+2), bih_mom(m+2);
  RowVector Xi2_lam(n);
  ComplexRowVector w=Xi;
  Complex a, b;
  double s, t;
  int i, k;

  s=0; t=0;
  for (i=0; i<n; i++){
    Xi2_lam(i)=(real(Xi(i))*real(Xi(i))+imag(Xi(i))*imag(Xi(i)))*lam(i);
    s+=lam(i); t+=Xi2_lam(i);
  } // for
  h_mom(0)=s; bih_mom(1)=t;

  for (k=1; k<=m; k++){
    a=lam(0)*w(0); b=Xi2_lam(0)*w(0); w(0)*=Xi(0);
    for (i=1; i<n; i++){
      a+=lam(i)*w(i); b+=Xi2_lam(i)*w(i); w(i)*=Xi(i);
    } // for
    h_mom(k)=a; bih_mom(k+1)=b;
  } // for
  a=lam(0)*w(0);
  for (i=1; i<n; i++)
    a+=lam(i)*w(i);
  h_mom(m+1)=a; bih_mom(0)=conj(h_mom(1));

retval(0)= h_mom;
retval(1)= bih_mom;
return retval;
}
